// +build !ignore_autogenerated

// Copyright 2018-2019 Zedge, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by controller-gen. DO NOT EDIT.

package model

import ()

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *AppIDUpdate) DeepCopyInto(out *AppIDUpdate) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new AppIDUpdate.
func (in *AppIDUpdate) DeepCopy() *AppIDUpdate {
	if in == nil {
		return nil
	}
	out := new(AppIDUpdate)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *EnumFieldUpdate) DeepCopyInto(out *EnumFieldUpdate) {
	*out = *in
	if in.From != nil {
		in, out := &in.From, &out.From
		*out = new(EventEnumField)
		(*in).DeepCopyInto(*out)
	}
	if in.To != nil {
		in, out := &in.To, &out.To
		*out = new(EventEnumField)
		(*in).DeepCopyInto(*out)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new EnumFieldUpdate.
func (in *EnumFieldUpdate) DeepCopy() *EnumFieldUpdate {
	if in == nil {
		return nil
	}
	out := new(EnumFieldUpdate)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *EnumUpdate) DeepCopyInto(out *EnumUpdate) {
	*out = *in
	if in.AddedFields != nil {
		in, out := &in.AddedFields, &out.AddedFields
		*out = make([]*EventEnumField, len(*in))
		for i := range *in {
			if (*in)[i] != nil {
				in, out := &(*in)[i], &(*out)[i]
				*out = new(EventEnumField)
				(*in).DeepCopyInto(*out)
			}
		}
	}
	if in.RemovedFields != nil {
		in, out := &in.RemovedFields, &out.RemovedFields
		*out = make([]*EventEnumField, len(*in))
		for i := range *in {
			if (*in)[i] != nil {
				in, out := &(*in)[i], &(*out)[i]
				*out = new(EventEnumField)
				(*in).DeepCopyInto(*out)
			}
		}
	}
	if in.UpdatedFields != nil {
		in, out := &in.UpdatedFields, &out.UpdatedFields
		*out = make([]*EnumFieldUpdate, len(*in))
		for i := range *in {
			if (*in)[i] != nil {
				in, out := &(*in)[i], &(*out)[i]
				*out = new(EnumFieldUpdate)
				(*in).DeepCopyInto(*out)
			}
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new EnumUpdate.
func (in *EnumUpdate) DeepCopy() *EnumUpdate {
	if in == nil {
		return nil
	}
	out := new(EnumUpdate)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in EnumValueSorter) DeepCopyInto(out *EnumValueSorter) {
	{
		in := &in
		*out = make(EnumValueSorter, len(*in))
		for i := range *in {
			if (*in)[i] != nil {
				in, out := &(*in)[i], &(*out)[i]
				*out = new(EventEnumField)
				(*in).DeepCopyInto(*out)
			}
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new EnumValueSorter.
func (in EnumValueSorter) DeepCopy() EnumValueSorter {
	if in == nil {
		return nil
	}
	out := new(EnumValueSorter)
	in.DeepCopyInto(out)
	return *out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *EventEnum) DeepCopyInto(out *EventEnum) {
	*out = *in
	if in.Fields != nil {
		in, out := &in.Fields, &out.Fields
		*out = make([]*EventEnumField, len(*in))
		for i := range *in {
			if (*in)[i] != nil {
				in, out := &(*in)[i], &(*out)[i]
				*out = new(EventEnumField)
				(*in).DeepCopyInto(*out)
			}
		}
	}
	if in.FieldMap != nil {
		in, out := &in.FieldMap, &out.FieldMap
		*out = make(map[string]*EventEnumField, len(*in))
		for key, val := range *in {
			var outVal *EventEnumField
			if val == nil {
				(*out)[key] = nil
			} else {
				in, out := &val, &outVal
				*out = new(EventEnumField)
				(*in).DeepCopyInto(*out)
			}
			(*out)[key] = outVal
		}
	}
	if in.ValueMap != nil {
		in, out := &in.ValueMap, &out.ValueMap
		*out = make(map[int]*EventEnumField, len(*in))
		for key, val := range *in {
			var outVal *EventEnumField
			if val == nil {
				(*out)[key] = nil
			} else {
				in, out := &val, &outVal
				*out = new(EventEnumField)
				(*in).DeepCopyInto(*out)
			}
			(*out)[key] = outVal
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new EventEnum.
func (in *EventEnum) DeepCopy() *EventEnum {
	if in == nil {
		return nil
	}
	out := new(EventEnum)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *EventEnumField) DeepCopyInto(out *EventEnumField) {
	*out = *in
	in.LastModified.DeepCopyInto(&out.LastModified)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new EventEnumField.
func (in *EventEnumField) DeepCopy() *EventEnumField {
	if in == nil {
		return nil
	}
	out := new(EventEnumField)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *EventProperty) DeepCopyInto(out *EventProperty) {
	*out = *in
	in.LastModified.DeepCopyInto(&out.LastModified)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new EventProperty.
func (in *EventProperty) DeepCopy() *EventProperty {
	if in == nil {
		return nil
	}
	out := new(EventProperty)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *EventTaxonomy) DeepCopyInto(out *EventTaxonomy) {
	*out = *in
	if in.Enums != nil {
		in, out := &in.Enums, &out.Enums
		*out = make([]*EventEnum, len(*in))
		for i := range *in {
			if (*in)[i] != nil {
				in, out := &(*in)[i], &(*out)[i]
				*out = new(EventEnum)
				(*in).DeepCopyInto(*out)
			}
		}
	}
	if in.Properties != nil {
		in, out := &in.Properties, &out.Properties
		*out = make([]*EventProperty, len(*in))
		for i := range *in {
			if (*in)[i] != nil {
				in, out := &(*in)[i], &(*out)[i]
				*out = new(EventProperty)
				(*in).DeepCopyInto(*out)
			}
		}
	}
	if in.BlacklistPropertiesFilter != nil {
		in, out := &in.BlacklistPropertiesFilter, &out.BlacklistPropertiesFilter
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.EnumMap != nil {
		in, out := &in.EnumMap, &out.EnumMap
		*out = make(map[string]*EventEnum, len(*in))
		for key, val := range *in {
			var outVal *EventEnum
			if val == nil {
				(*out)[key] = nil
			} else {
				in, out := &val, &outVal
				*out = new(EventEnum)
				(*in).DeepCopyInto(*out)
			}
			(*out)[key] = outVal
		}
	}
	if in.PropertyMap != nil {
		in, out := &in.PropertyMap, &out.PropertyMap
		*out = make(map[string]*EventProperty, len(*in))
		for key, val := range *in {
			var outVal *EventProperty
			if val == nil {
				(*out)[key] = nil
			} else {
				in, out := &val, &outVal
				*out = new(EventProperty)
				(*in).DeepCopyInto(*out)
			}
			(*out)[key] = outVal
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new EventTaxonomy.
func (in *EventTaxonomy) DeepCopy() *EventTaxonomy {
	if in == nil {
		return nil
	}
	out := new(EventTaxonomy)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *LifecycleUpdate) DeepCopyInto(out *LifecycleUpdate) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new LifecycleUpdate.
func (in *LifecycleUpdate) DeepCopy() *LifecycleUpdate {
	if in == nil {
		return nil
	}
	out := new(LifecycleUpdate)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *PropertyUpdate) DeepCopyInto(out *PropertyUpdate) {
	*out = *in
	if in.From != nil {
		in, out := &in.From, &out.From
		*out = new(EventProperty)
		(*in).DeepCopyInto(*out)
	}
	if in.To != nil {
		in, out := &in.To, &out.To
		*out = new(EventProperty)
		(*in).DeepCopyInto(*out)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new PropertyUpdate.
func (in *PropertyUpdate) DeepCopy() *PropertyUpdate {
	if in == nil {
		return nil
	}
	out := new(PropertyUpdate)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *TaxonomyUpdate) DeepCopyInto(out *TaxonomyUpdate) {
	*out = *in
	if in.AppID != nil {
		in, out := &in.AppID, &out.AppID
		*out = new(AppIDUpdate)
		**out = **in
	}
	if in.AddedEnums != nil {
		in, out := &in.AddedEnums, &out.AddedEnums
		*out = make([]*EventEnum, len(*in))
		for i := range *in {
			if (*in)[i] != nil {
				in, out := &(*in)[i], &(*out)[i]
				*out = new(EventEnum)
				(*in).DeepCopyInto(*out)
			}
		}
	}
	if in.RemovedEnums != nil {
		in, out := &in.RemovedEnums, &out.RemovedEnums
		*out = make([]*EventEnum, len(*in))
		for i := range *in {
			if (*in)[i] != nil {
				in, out := &(*in)[i], &(*out)[i]
				*out = new(EventEnum)
				(*in).DeepCopyInto(*out)
			}
		}
	}
	if in.UpdatedEnums != nil {
		in, out := &in.UpdatedEnums, &out.UpdatedEnums
		*out = make([]*EnumUpdate, len(*in))
		for i := range *in {
			if (*in)[i] != nil {
				in, out := &(*in)[i], &(*out)[i]
				*out = new(EnumUpdate)
				(*in).DeepCopyInto(*out)
			}
		}
	}
	if in.AddedProperties != nil {
		in, out := &in.AddedProperties, &out.AddedProperties
		*out = make([]*EventProperty, len(*in))
		for i := range *in {
			if (*in)[i] != nil {
				in, out := &(*in)[i], &(*out)[i]
				*out = new(EventProperty)
				(*in).DeepCopyInto(*out)
			}
		}
	}
	if in.RemovedProperties != nil {
		in, out := &in.RemovedProperties, &out.RemovedProperties
		*out = make([]*EventProperty, len(*in))
		for i := range *in {
			if (*in)[i] != nil {
				in, out := &(*in)[i], &(*out)[i]
				*out = new(EventProperty)
				(*in).DeepCopyInto(*out)
			}
		}
	}
	if in.UpdatedProperties != nil {
		in, out := &in.UpdatedProperties, &out.UpdatedProperties
		*out = make([]*PropertyUpdate, len(*in))
		for i := range *in {
			if (*in)[i] != nil {
				in, out := &(*in)[i], &(*out)[i]
				*out = new(PropertyUpdate)
				(*in).DeepCopyInto(*out)
			}
		}
	}
	if in.BlacklistedProperties != nil {
		in, out := &in.BlacklistedProperties, &out.BlacklistedProperties
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new TaxonomyUpdate.
func (in *TaxonomyUpdate) DeepCopy() *TaxonomyUpdate {
	if in == nil {
		return nil
	}
	out := new(TaxonomyUpdate)
	in.DeepCopyInto(out)
	return out
}
